Attribute VB_Name = "modTags"
Public Type typeTag
  Tag As String
  Question As String
  Description As String
  isOptional As Boolean
  isMultiLine As Boolean
  
End Type

Public TagsNr As Long
Public TagsNrMax As Long
Public Tags() As typeTag

Public Sub InitTags()
On Error Resume Next
ReDim Preserve Tags(1 To 1024)

TagsNr = 0
TagsNrMax = 1024

End Sub

Public Function ScanForTags(Data As String) As Long
Dim s As String
Dim TextLen As Long
Dim i As Long
Dim Count As Long
Dim text As String
InitTags
text = Data
TextLen = Len(text)
i = 1
If TextLen = 0 Then
   ScanForTags = 0
   Exit Function
End If
Pos = InStr(1, text, "[#")
While Pos > 0
  Pos = Pos + 2
  s = ""
  While Mid$(text, Pos, 2) <> "#]" And Pos < TextLen
     s = s & Mid$(text, Pos, 1)
     Pos = Pos + 1
  Wend
  If IsTag("[#" & s & "#]") = False Then
  TagsNr = TagsNr + 1
  If TagsNr <= TagsNrMax Then
    Tags(TagsNr).Tag = "[#" & s & "#]"
  End If
  Count = Count + 1
  End If
  Pos = Pos + 1
  Pos = InStr(Pos, text, "[#")
Wend
ScanForTags = Count
End Function

Private Function IsTag(TagName As String) As Boolean
Dim i As Long
If TagsNr < 1 Then
  IsTag = False
  Exit Function
End If
For i = 1 To TagsNr
  If Tags(i).Tag = TagName Then
     IsTag = True
     Exit Function
  End If
Next i
IsTag = False
Exit Function

End Function
