Attribute VB_Name = "ModINI"
Option Explicit

Public Declare Function WritePrivateProfileString Lib "Kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileString Lib "Kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Const Error_Text As String = "@#$%*)(ErRoR tExT"

Public INIFile As String

Public Sub ReadStringSetting(Regiune As String, text As String, ByRef Value As String)
Dim a As Long
Dim ret As String
ret = String(255, 0)
a = GetPrivateProfileString(Regiune, text, Error_Text, ret, 255, INIFile)
If a <> 0 Then ret = Left$(ret, a)
If ret <> Error_Text Then Value = ret
End Sub

'Public Sub ReadLongSetting(Regiune As String, text As String, ByRef Value As Long)
'Dim a As Long
'Dim ret As String
'ret = String(255, 0)
'a = GetPrivateProfileString(Regiune, text, Error_Text, ret, 255, INIFile)
'If a <> 0 Then ret = Left$(ret, a)
'If ret <> Error_Text Then Value = CLng(ret)
'End Sub

'
' Commented to reduce exe size (functions below not used by application)
'

'Public Sub ReadBoolSetting(Regiune As String, text As String, ByRef Value As Boolean)
'Dim a As Long
'Dim ret As String
'ret = String(255, 0)
'a = GetPrivateProfileString(Regiune, text, Error_Text, ret, 255, INIFile)
'If a <> 0 Then ret = Left$(ret, a)
'If ret <> Error_Text Then
'   If ret = "0" Then
'      Value = False
'   Else
'      Value = True
'   End If
'End If
'End Sub


'Public Sub WriteStringSetting(Regiune As String, text As String, Value As String)
'WritePrivateProfileString Regiune, text, Value, INIFile
'End Sub

'Public Sub WriteLongSetting(Regiune As String, text As String, Value As Long)
'WritePrivateProfileString Regiune, text, Trim$(CStr(Value)), INIFile
'End Sub

'Public Sub WriteBoolSetting(Regiune As String, text As String, Value As Boolean)
'Dim val As String
'Select Case Value
'Case True: val = "1"
'Case False: val = "0"
'End Select
'WritePrivateProfileString Regiune, text, val, INIFile
'End Sub
